
// Author:  David Martin  <dmartin@eecs.berkeley.edu>

import java.io.*;

// Provide BufferedReader.readLine() access to an array of Strings.

public class BufferedStringReader 
    extends BufferedReader
{
    String[] strings;
    int nextIndex;

    public BufferedStringReader (String[] strings) {
	super (new StringReader (""));
	this.strings = strings;
	nextIndex = 0;
    }

    public void close () {
	nextIndex = strings.length;
    }

    public int read () throws IOException { 
	throw new IOException (
	    "BufferedStringReader.read(void) not supported."); 
    }

    public int read (char[] cbuf) throws IOException {
	throw new IOException (
	    "BufferedStringReader.read(char[]) not supported."); 
    }

    public int read (char[] cbuf, int off, int len) throws IOException {
	throw new IOException (
	    "BufferedStringReader.read(char[],int,int) not supported."); 
    }

    public String readLine () {
	if (nextIndex >= strings.length) {
	    return null;
	} else {
	    return new String (strings[nextIndex++]);
	}
    }

    public boolean ready () {
	return true;
    }

    public boolean markSupported () {
	return false;
    }

    public void reset () throws IOException {
	throw new IOException (
	    "BufferedStringReader.reset(void) not supported."); 
    }

    public long skip () throws IOException {
	throw new IOException (
	    "BufferedStringReader.skip(void) not supported."); 
    }
};
